<template>
    <h2>Contact</h2>
    <div class="container-form">
        <div class="container-form-left">
            <div class="name">
                <label for="nom">Nom</label>
                <input type="text" name="nom" id="nom" v-model="nom">
            </div>
            <div class="email">
                <label for="mail">Adresse mail</label>
                <input type="mail" name="mail" id="mail" v-model="mail">
            </div>
        </div>

        <div class="container-form-right">
            <div class="message">
                <label for="mess">Message</label>
                <textarea name="mess" id="mess" cols="30" rows="10" v-model="message"></textarea>
            </div>
        </div>
    </div>

    <div class="information">
        <div class="send" @click="send()">
            <p>Envoyer</p>
        </div>
        <transition name="fade">
            <div v-show="show" class="info">
                <img src="../assets/img/warning.png" alt="">
                <span>{{ error }}</span>
            </div>
        </transition>
    </div>


</template>

<script>

import axios from 'axios'

export default {
    name: "ContactPage",
    data(){
        return{
            nom: "",
            mail: "",
            message: "",
            error: "",
            show: false,
            api_url:"http://localhost:5000/add/contact"
        }
    },
    methods:{
        async getIPv4(){
            const url = "https://ipgeolocation.abstractapi.com/v1/?api_key="
            const key = "1be9a6884abd4c3ea143b59ca317c6b2"
            const data = await axios.get(url+key)
            return data.data.ip_address
        },
        async sendApi(){
            axios
            .post(this.api_url,{
                nom:this.nom,
                mail: this.mail,
                message:this.message,
                ip: await this.getIPv4()
            })
            .then(response =>{

                if (response.status == 200){
                    this.error = "Votre message, a bien été envoyé 😉"
                    this.show = true
                    setTimeout(()=>this.$router.push('/'),2000)
                }
                else if (response.status == 203){
                    this.error = "Il semble que vous avez déjà envoyer un message aujourd'hui."
                    this.show = true
                }
                
            })
            .catch(response =>{
                console.log(response)
            })
        },
        send(){
            switch (this.checkField()){
                case -1:
                    this.error = "L'un des champs est incomplet."
                    this.show = true
                    break;
                case 0:
                    this.error = "Email incorrect."
                    this.show = true
                    break;
                case 1:
                    this.show = false
                    this.sendApi()
                    break;
            }
        },
        checkField(){
            const regexMail = /^[\w-\.]+@([\w-]+\.)+[\w-]{2,4}$/gm
            if (this.nom.trim() == "" || this.mail.trim() == "" || this.message.trim() == ""){
                return -1
            }
            else if(!this.mail.match(regexMail)){
                return 0
            }

            return 1
        }
    }
}
</script>

<style lang="scss" scoped>

@import "../style/default";

.container-form{

    display: flex;

    margin-left: 5%;

    width: 90%;

    font-family: $default_font;

    margin-top:3%;
    margin-bottom: 3%;


    input[type="text"], input[type="mail"]{
        font-size: 2em;
        letter-spacing: 2.5px;
        width: 80%;
        outline: none;
        border:1px solid black;
        border-radius: 5px;
    }

    label{
        font-size: 2em;
        margin-bottom: 3%;
    }

    &-left{
        width: 60%;

        display: flex;

        flex-direction: column;

        gap:20%;

        justify-content: center;

        .name,.email{
            display: flex;
            flex-direction: column;

            text-align: start;
        }
    }

    &-right{
        width: 40%;
        //border:2px solid black;

        display: flex;

        flex-direction: column;

        .message{
            display: flex;
            flex-direction: column;

            text-align: start;

            textarea{
                resize: none;
                height: 100%;

                font-size:1.75em;
                outline: none;

            }
        }
    }
}

.information{

    display: flex;

    margin-left: 5%;

    width: 90%;

    font-family: $default_font;

    align-items: center;
    gap:20%;


    .send{

        position: relative;

        cursor: pointer;
        border:2px solid $background_green;


        border-radius: 5px;

        background-color: $background_green;

        width: 20%;

        font-size: 1.2em;


        color:white;

        &::before,&::after{
            content: "";
            position: absolute;
            width: 30px;
            height: 30px;
            background-color: white;


            transform: rotate(40deg);
        }

        &::before{

            top:25%;
            left:-40px;

            transition:left .5s ease-in;
        }

        &::after{
            top:25%;
            right:-40px;

            transition:right .5s ease-in;
        }

        &:hover::before{
            left:-18px;
        }

        &:hover::after{
            right:-18px;
        }


    }

    .info{
        display: inline-flex;
        width: 100%;
        justify-content: center;
        align-items:baseline;
        gap:5%;
        img{
            width: 50px;
        }
    }
}



.fade-enter-active, .fade-leave-active {
  transition: opacity .5s;
}
.fade-enter, .fade-leave-to{
  opacity: 0;
}
</style>